package com.halo.halojuhesdk.core.channel.applovin;

import android.app.Activity;
import android.util.Log;

import com.applovin.mediation.MaxAd;
import com.applovin.mediation.MaxAdListener;
import com.applovin.mediation.MaxError;
import com.applovin.mediation.ads.MaxAppOpenAd;
import com.applovin.mediation.ads.MaxInterstitialAd;
import com.halo.halojuhesdk.core.base.utils.CompareEcpmUtils;
import com.halo.halojuhesdk.core.base.utils.LogUtils;
import com.halo.halojuhesdk.core.channel.IInsertAd;
import com.halo.halojuhesdk.core.channel.IInsertProxyListener;
import com.halo.halojuhesdk.core.channel.ISplashAd;
import com.halo.halojuhesdk.core.channel.ISplashProxyListener;
import com.halo.halojuhesdk.core.request.EcpmCompareBean;
import com.halo.halojuhesdk.core.request.InitDataProcessor;
import com.halo.halojuhesdk.core.request.SlotBean;
import com.halo.halojuhesdk.sdk.HlAdClient;

public class AppLovinSplash implements ISplashAd, MaxAdListener {
    private MaxAppOpenAd appOpenAd;
    private SlotBean mLovinBean;
    private ISplashProxyListener mListener;
    private boolean isShow = true;
    private boolean isClick = false;
    public AppLovinSplash(Activity activity, SlotBean bean, ISplashProxyListener listener) {
        this.mListener = listener;
        this.mLovinBean = bean;
        isShow = true;
        isClick = false;
        LogUtils.e("====AppLovinSplash===");
        InitDataProcessor.initAppLovin(activity);
        mLovinBean.setStartTime(System.currentTimeMillis());
        appOpenAd = new MaxAppOpenAd(bean.adSlotId, activity);
        appOpenAd.setListener(this);
        appOpenAd.loadAd();
    }

    @Override
    public void LoadAndShowAd() {
        appOpenAd.showAd();
    }

    @Override
    public void onAdLoaded(MaxAd maxAd) {
        mLovinBean.setEndTime(System.currentTimeMillis());
        double ecpm = maxAd.getRevenue()*1000;
        Log.e("11111","====onSplashAdLoaded====" + ecpm);
        mLovinBean.setEp(ecpm);
        EcpmCompareBean bean = CompareEcpmUtils.compareEcpm(mLovinBean, ecpm);
        mLovinBean.setOp(bean.getEcpm());
        if (bean.getResult()) {
            mListener.onReadyAd(mLovinBean, InitDataProcessor.SDK_MAX, bean.getEcpm(), maxAd.getNetworkName());
        } else {
            mListener.onAdError("applovin: 竞价失败", 102, InitDataProcessor.SDK_MAX, mLovinBean);
        }
    }

    @Override
    public void onAdDisplayed(MaxAd maxAd) {
        if (mListener != null) {
            if (isShow) {
                isShow = false;
                mListener.onDisplayAd(mLovinBean, maxAd.getNetworkName());
            }
        }
    }

    @Override
    public void onAdHidden(MaxAd maxAd) {
        if (mListener != null) {
            mListener.onCloseAd();
        }
    }

    @Override
    public void onAdClicked(MaxAd maxAd) {
        if (!isClick) {
            isClick = true;
            if (mListener != null) {
                mListener.onClickAd(mLovinBean, maxAd.getNetworkName());
            }
        }
    }

    @Override
    public void onAdLoadFailed(String s, MaxError maxError) {
        mLovinBean.setEndTime(System.currentTimeMillis());
        Log.e("11111","====onSplashAdLoadFailed====" + maxError.getMessage());
        if (mListener != null) {
            mListener.onAdError("lovin:error===" + maxError.getMessage(), maxError.getCode(), InitDataProcessor.SDK_MAX, mLovinBean);
        }
    }

    @Override
    public void onAdDisplayFailed(MaxAd maxAd, MaxError maxError) {

    }
}
