package com.halo.halojuhesdk.core.request;

import static com.halo.halojuhesdk.core.common.SDKInfo.SDK_VERSION;

import android.text.TextUtils;

import com.halo.halojuhesdk.core.base.LaunchMode;
import com.halo.halojuhesdk.core.base.ReqType;
import com.halo.halojuhesdk.core.base.net.AbstractNetTask;
import com.halo.halojuhesdk.core.base.utils.LogUtils;
import com.halo.halojuhesdk.core.base.utils.SystemUtils;
import com.halo.halojuhesdk.core.common.utils.HttpUrlSettings;
import com.halo.halojuhesdk.core.common.utils.MyUtils;

import java.io.OutputStream;
import java.net.HttpURLConnection;

/**
 * 统一请求类，如果需要post请求，请继承该类复写getEntity方法,和getReqType
 */

public class InitDataTask extends AbstractNetTask {
    private String mJsonInfo;
    private String mAppId;


    public InitDataTask(String appId, String jsonInfo) {
        super(MyUtils.getContext(), false);
        mJsonInfo = jsonInfo;
        mAppId = appId;
    }

    @Override
    public String getURL() {
        String urlStr = HttpUrlSettings.getInitUrl() + "appid="
                + mAppId + "&sdk=" + SDK_VERSION
                + "&versionCode=" + SystemUtils.getAppVer()
                + "&adid=" + HlStatisManager.getInstance().getConfigReqId();
        LogUtils.e("===1111====" + urlStr);
      return urlStr;
    }

    /**
     * post请求
     *
     * @param outputStream
     */
    @Override
    protected void getEntity(OutputStream outputStream) {
        try {
            if (outputStream != null && !TextUtils.isEmpty(mJsonInfo)) {
                outputStream.write(mJsonInfo.getBytes());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    protected void onAddHeaders(HttpURLConnection connection) {
        connection.setRequestProperty("Content-Type","application/json");
    }

    @Override
    protected ReqType getReqType() {
        return ReqType.Post;
    }

    @Override
    public LaunchMode getLaunchMode() {
        return LaunchMode.addnew;
    }

    @Override
    public String getName() {
        return "InitDataTask";
    }
}
