package com.halo.halojuhesdk.core.request;


import android.util.Log;

import com.halo.halojuhesdk.core.base.net.AbstractNetProcessor;
import com.halo.halojuhesdk.core.base.net.AbstractNetTask;
import com.halo.halojuhesdk.core.base.utils.LogUtils;
import com.sensorsdata.analytics.android.sdk.SensorsDataAPI;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import javax.net.ssl.HttpsURLConnection;

/**
 * 请求数据的percessor
 */

public class StatProcessor extends AbstractNetProcessor {

    private String mReqId;
    private String mPostjson;

    public StatProcessor(String postjson, String reqId) {
        mPostjson = postjson;
        mReqId = reqId;
    }

    @Override
    protected AbstractNetTask createTask() {
        return new StatTask(mPostjson, mReqId);
    }


    @Override
    public void finish(int code, String content) {
        if (code == HttpsURLConnection.HTTP_OK) {
            LogUtils.e("==StatProcessor===" + mPostjson);
            reportSensorsData(0, code, content);
        }
    }

    @Override
    public void onError(int code, String content) {
        //根据code 判断是否需要增加失败次数
        Log.e("==StatProcessorError===", "code:  " + code + " content: " + content);
        reportSensorsData(1, code, content);
    }

    private void reportSensorsData(int type, int code, String content) {
        JSONObject jsonObject = new JSONObject();
        try {
            JSONArray jsonArray = new JSONArray(mPostjson);
            if (jsonArray.length() > 0) {
                String slotId = jsonArray.getJSONObject(0).optString("slotId");
                jsonObject.put("slotId", slotId);
            }
            jsonObject.put("errorCode", code);
            jsonObject.put("msgContent", content);
            jsonObject.put("postJson", mPostjson);
            String eventIdStr = "";
            if (type == 0) {
                eventIdStr = "sdk_juhe_request_success";
            } else if (type == 1){
                eventIdStr = "sdk_juhe_request_error";
            }
            LogUtils.e("===reportSensor===" + jsonObject);
            SensorsDataAPI.sharedInstance().track(eventIdStr, jsonObject);
        } catch (JSONException e) {
            throw new RuntimeException(e);
        }
    }
}
