package com.halo.halojuhesdk.sdk;

import android.app.Activity;
import android.content.Context;
import android.text.TextUtils;

import com.halo.halojuhesdk.core.base.HjTaskManager;
import com.halo.halojuhesdk.core.channel.ChannelInitAdapter;
import com.halo.halojuhesdk.core.common.utils.Config;
import com.halo.halojuhesdk.core.common.utils.MyUtils;
import com.halo.halojuhesdk.core.request.InitDataProcessor;
import com.halo.halojuhesdk.core.request.SlotBean;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;


/**
 * @author Feng Zhanao
 * @date 2018/7/3
 * @description 初四画
 */
public class HlAdClient {
    public static Map<String, List<SlotBean>> slotMap = new ConcurrentHashMap<>();
    public static Map<String, Boolean> containApiMap = new ConcurrentHashMap<>();
    public static Map<String, Boolean> initSuccessMap = new ConcurrentHashMap<>();
    public static List<Config.JuHeAdType> mTypeList = new ArrayList<>();
    public static String mConfigInfo;
    public static boolean isGetAppInfo = false;


    /**
     * @param context 上下文Context
     * @param appId   广告appID
     * @return boolean 是否初始化成功
     */
    public static void init(Context context, String configInfo, String appId, boolean isGetInfo) {
        init(context, appId, configInfo,isGetInfo,false);
    }

    /**
     * 初始化方法
     *
     * @param context 上下文
     * @param appId   媒体id
     * @return 是否初始化成功
     */
    public static boolean init(Context context, String appId, String configInfo, boolean isGetInfo, boolean isDebug) {
        if (context == null || TextUtils.isEmpty(appId)) {
            return false;
        }
        addAdTypeList();
        isGetAppInfo = isGetInfo;
        mConfigInfo = configInfo;
        MyUtils.init(context, isDebug);
        Config.init(appId);
        initConfig(context);
        return true;
    }

    public static void addAdTypeList() {
        List<Config.JuHeAdType> juHeAdTypeList = new ArrayList<>();
        juHeAdTypeList.add(Config.JuHeAdType.MAX);
        juHeAdTypeList.add(Config.JuHeAdType.API);
        ChannelInitAdapter channelInitAdapter = new ChannelInitAdapter();
        for (int i = 0; i < juHeAdTypeList.size(); i++) {
            channelInitAdapter.verifyInitClass(juHeAdTypeList.get(i));
        }
    }

    public static void initConfig(Context context) {
        InitDataProcessor processor = new InitDataProcessor(context, Config.mAppId);
        processor.setTaskManager(new HjTaskManager(MyUtils.getContext(), HjTaskManager.MOD_SINGLE));
        processor.process();
    }
}
